{ File    : $URL: file:///D:/SVN/svnDelphi/branches/A%20New%20Beginning/VISExt/servicing/src/convert/VEDMap.pas $
  Author  : $Author: Deniz Oezmen $
  Changed : $Date: 2021-04-03 22:48:36 +0200 (Sa, 03 Apr 2021) $
  Revision: $Rev: 588 $

  Visionaire Engine types and mappings
}
unit VEDMap;

interface

type
  TVisType = (VT_Bool, VT_Int, VT_String, VT_Path, VT_Float, VT_Text, VT_VRect,
    VT_VSprite, VT_VPoint, VT_VString, VT_VInt, VT_VPath, VT_VFloat, VT_Point,
    VT_Rect, VT_Sprite, VT_Link, VT_Links, VT_VText, VT_Table, VT_VBool,
    VT_Unknown);

const
  MaxVisIdentifierID = 916;

  BasicVisTypes: set of TVisType =
    [VT_Bool, VT_Int, VT_String, VT_Path, VT_Float];

  StructuredVisTypes: set of TVisType =
    [VT_Text, VT_VRect, VT_VSprite, VT_VPoint, VT_VString, VT_VInt, VT_VPath,
     VT_VFloat, VT_Point, VT_Rect, VT_Sprite, VT_Link, VT_Links, VT_VText,
     VT_Table, VT_VBool];

function MapVisType(const NameID: Word): TVisType;
function MapTableId(const NameID: Word): Longint;

implementation

uses
  SysUtils;

const
  VisTypeMapping: array[1..MaxVisIdentifierID] of TVisType =
           {0}         {1}         {2}         {3}         {4}         {5}         {6}         {7}         {8}         {9}
    {001} ({         } VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Path   , VT_Point  , VT_Rect   ,
    {010}  VT_Point  , VT_Unknown, VT_String , VT_Int    , VT_Int    , VT_Link   , VT_Links  , VT_Int    , VT_Int    , VT_Int    ,
    {020}  VT_Unknown, VT_Bool   , VT_Rect   , VT_Unknown, VT_Point  , VT_String , VT_Text   , VT_Int    , VT_Unknown, VT_Sprite ,
    {030}  VT_Unknown, VT_Unknown, VT_Int    , VT_Unknown, VT_Float  , VT_Unknown, VT_Bool   , VT_Unknown, VT_Links  , VT_Unknown,
    {040}  VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Bool   , VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown,
    {050}  VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Unknown, VT_Unknown,
    {060}  VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown,
    {070}  VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown,
    {080}  VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown,
    {090}  VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown,
           {0}         {1}         {2}         {3}         {4}         {5}         {6}         {7}         {8}         {9}
    {100}  VT_Table  , VT_Links  , VT_Links  , VT_Links  , VT_Links  , VT_Links  , VT_Links  , VT_Links  , VT_Links  , VT_Links  ,
    {110}  VT_Links  , VT_Links  , VT_Links  , VT_Links  , VT_Links  , VT_Links  , VT_Table  , VT_Links  , VT_Links  , VT_Unknown,
    {120}  VT_Links  , VT_Link   , VT_Unknown, VT_Unknown, VT_String , VT_String , VT_Point  , VT_Unknown, VT_Unknown, VT_Table  ,
    {130}  VT_Unknown, VT_Unknown, VT_Path   , VT_Int    , VT_Unknown, VT_Unknown, VT_Links  , VT_Table  , VT_Int    , VT_Unknown,
    {140}  VT_Links  , VT_Table  , VT_Unknown, VT_VRect  , VT_Table  , VT_Int    , VT_Point  , VT_Links  , VT_Table  , VT_Unknown,
    {150}  VT_Unknown, VT_Links  , VT_Table  , VT_Int    , VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Table  , VT_Int    ,
    {160}  VT_Link   , VT_Link   , VT_Links  , VT_Table  , VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Link   ,
    {170}  VT_Link   , VT_Link   , VT_Links  , VT_Unknown, VT_Links  , VT_Links  , VT_Links  , VT_Unknown, VT_Table  , VT_Int    ,
    {180}  VT_Link   , VT_Path   , VT_Table  , VT_Unknown, VT_Bool   , VT_Bool   , VT_Bool   , VT_Int    , VT_Int    , VT_Point  ,
    {190}  VT_Link   , VT_Unknown, VT_Table  , VT_Bool   , VT_Bool   , VT_Bool   , VT_Bool   , VT_Bool   , VT_Int    , VT_Link   ,
           {0}         {1}         {2}         {3}         {4}         {5}         {6}         {7}         {8}         {9}
    {200}  VT_Link   , VT_Table  , VT_Links  , VT_Table  , VT_Link   , VT_Link   , VT_Link   , VT_Table  , VT_Unknown, VT_Table  ,
    {210}  VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Links  , VT_Unknown, VT_Unknown, VT_Unknown, VT_Bool   ,
    {220}  VT_Unknown, VT_Unknown, VT_Int    , VT_Unknown, VT_Path   , VT_Links  , VT_Table  , VT_Unknown, VT_Unknown, VT_Link   ,
    {230}  VT_Unknown, VT_Unknown, VT_Bool   , VT_Unknown, VT_Int    , VT_VSprite, VT_Sprite , VT_Sprite , VT_Sprite , VT_Point  ,
    {240}  VT_VSprite, VT_VSprite, VT_Int    , VT_Unknown, VT_Int    , VT_Int    , VT_Int    , VT_Bool   , VT_Sprite , VT_String ,
    {250}  VT_Int    , VT_Link   , VT_Unknown, VT_Links  , VT_Links  , VT_Table  , VT_String , VT_Path   , VT_Link   , VT_Links  ,
    {260}  VT_Links  , VT_Table  , VT_Links  , VT_Table  , VT_Links  , VT_Links  , VT_Table  , VT_Links  , VT_Links  , VT_Links  ,
    {270}  VT_Int    , VT_Link   , VT_Path   , VT_Unknown, VT_Unknown, VT_Link   , VT_Link   , VT_Link   , VT_Links  , VT_Links  ,
    {280}  VT_Links  , VT_Links  , VT_Links  , VT_Link   , VT_Link   , VT_Int    , VT_Link   , VT_Int    , VT_Bool   , VT_Link   ,
    {290}  VT_Link   , VT_Int    , VT_Bool   , VT_Link   , VT_Unknown, VT_Link   , VT_Link   , VT_Int    , VT_Link   , VT_Unknown,
           {0}         {1}         {2}         {3}         {4}         {5}         {6}         {7}         {8}         {9}
    {300}  VT_Unknown, VT_Unknown, VT_Point  , VT_Link   , VT_Int    , VT_Bool   , VT_Link   , VT_Unknown, VT_Unknown, VT_Link   ,
    {310}  VT_Rect   , VT_Link   , VT_Unknown, VT_Unknown, VT_Int    , VT_Int    , VT_Int    , VT_Bool   , VT_Links  , VT_Rect   ,
    {320}  VT_Link   , VT_Links  , VT_VRect  , VT_Int    , VT_Int    , VT_VPoint , VT_Links  , VT_Table  , VT_Int    , VT_Int    ,
    {330}  VT_Links  , VT_Links  , VT_Links  , VT_Links  , VT_Links  , VT_Links  , VT_Int    , VT_Link   , VT_Bool   , VT_Point  ,
    {340}  VT_Unknown, VT_VPoint , VT_Link   , VT_Link   , VT_Bool   , VT_Bool   , VT_Int    , VT_Int    , VT_Link   , VT_Links  ,
    {350}  VT_Bool   , VT_Links  , VT_Table  , VT_Sprite , VT_Unknown, VT_Sprite , VT_Bool   , VT_Path   , VT_Link   , VT_Bool   ,
    {360}  VT_Sprite , VT_Unknown, VT_Unknown, VT_Unknown, VT_Link   , VT_Bool   , VT_Bool   , VT_Point  , VT_Link   , VT_String ,
    {370}  VT_String , VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Unknown, VT_Int    , VT_Int    , VT_Int    , VT_Link   ,
    {380}  VT_Int    , VT_Link   , VT_Unknown, VT_Links  , VT_Bool   , VT_Int    , VT_Link   , VT_Bool   , VT_Link   , VT_Bool   ,
    {390}  VT_Links  , VT_Table  , VT_Path   , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Float  , VT_Float  , VT_Int    ,
           {0}         {1}         {2}         {3}         {4}         {5}         {6}         {7}         {8}         {9}
    {400}  VT_Float  , VT_Float  , VT_Float  , VT_Int    , VT_Float  , VT_Int    , VT_Int    , VT_Float  , VT_Float  , VT_Float  ,
    {410}  VT_Float  , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    ,
    {420}  VT_Int    , VT_Int    , VT_VFloat , VT_VFloat , VT_VFloat , VT_VFloat , VT_VInt   , VT_VInt   , VT_VInt   , VT_VInt   ,
    {430}  VT_Int    , VT_Float  , VT_Int    , VT_Int    , VT_Float  , VT_Float  , VT_Float  , VT_Float  , VT_VFloat , VT_VInt   ,
    {440}  VT_Unknown, VT_Link   , VT_Int    , VT_Int    , VT_VFloat , VT_VInt   , VT_Float  , VT_Float  , VT_Links  , VT_Links  ,
    {450}  VT_Table  , VT_Links  , VT_Links  , VT_Links  , VT_VPoint , VT_Links  , VT_Bool   , VT_Link   , VT_Rect   , VT_Sprite ,
    {460}  VT_Sprite , VT_Sprite , VT_Sprite , VT_Sprite , VT_Int    , VT_Link   , VT_Bool   , VT_Link   , VT_Link   , VT_Link   ,
    {470}  VT_Point  , VT_Point  , VT_Bool   , VT_Int    , VT_Int    , VT_Bool   , VT_Link   , VT_Link   , VT_Links  , VT_Bool   ,
    {480}  VT_Bool   , VT_Link   , VT_Link   , VT_Link   , VT_Link   , VT_Bool   , VT_Link   , VT_Bool   , VT_Bool   , VT_Int    ,
    {490}  VT_Int    , VT_Bool   , VT_Int    , VT_Int    , VT_Int    , VT_Point  , VT_Point  , VT_Int    , VT_Link   , VT_Float  ,
           {0}         {1}         {2}         {3}         {4}         {5}         {6}         {7}         {8}         {9}
    {500}  VT_Bool   , VT_Int    , VT_Bool   , VT_Link   , VT_Link   , VT_Link   , VT_Link   , VT_Int    , VT_Int    , VT_Unknown,
    {510}  VT_Unknown, VT_Int    , VT_Point  , VT_Point  , VT_Unknown, VT_Link   , VT_Unknown, VT_Link   , VT_Int    , VT_Unknown,
    {520}  VT_Unknown, VT_String , VT_String , VT_Point  , VT_Int    , VT_Int    , VT_Link   , VT_Bool   , VT_Link   , VT_Bool   ,
    {530}  VT_Bool   , VT_Table  , VT_Links  , VT_Table  , VT_Links  , VT_Table  , VT_Links  , VT_String , VT_Int    , VT_Int    ,
    {540}  VT_Int    , VT_Bool   , VT_Int    , VT_Link   , VT_Bool   , VT_Link   , VT_Links  , VT_Int    , VT_Int    , VT_Int    ,
    {550}  VT_Path   , VT_Unknown, VT_Unknown, VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Links  , VT_Table  , VT_Link   ,
    {560}  VT_Link   , VT_Bool   , VT_Int    , VT_Link   , VT_Int    , VT_Bool   , VT_Int    , VT_Bool   , VT_Rect   , VT_Links  ,
    {570}  VT_Table  , VT_Int    , VT_Path   , VT_Int    , VT_Int    , VT_Link   , VT_Links  , VT_Bool   , VT_Bool   , VT_Link   ,
    {580}  VT_Bool   , VT_Link   , VT_Bool   , VT_Int    , VT_Links  , VT_Links  , VT_Bool   , VT_Bool   , VT_Int    , VT_Link   ,
    {590}  VT_Rect   , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Link   , VT_Int    ,
           {0}         {1}         {2}         {3}         {4}         {5}         {6}         {7}         {8}         {9}
    {600}  VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Bool   , VT_Link   , VT_Links  , VT_Int    ,
    {610}  VT_Link   , VT_Link   , VT_Int    , VT_Bool   , VT_Bool   , VT_Int    , VT_Path   , VT_Int    , VT_Path   , VT_Int    ,
    {620}  VT_Path   , VT_Int    , VT_Path   , VT_Int    , VT_Link   , VT_Link   , VT_Link   , VT_String , VT_Bool   , VT_Bool   ,
    {630}  VT_Int    , VT_Int    , VT_String , VT_Link   , VT_Bool   , VT_Int    , VT_Links  , VT_Table  , VT_VPoint , VT_Links  ,
    {640}  VT_Links  , VT_Link   , VT_Bool   , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Link   , VT_Link   , VT_Links  ,
    {650}  VT_Table  , VT_Links  , VT_String , VT_Int    , VT_String , VT_Link   , VT_Int    , VT_Links  , VT_Table  , VT_Link   ,
    {660}  VT_String , VT_Links  , VT_Links  , VT_Links  , VT_Int    , VT_Link   , VT_Point  , VT_Int    , VT_Int    , VT_Int    ,
    {670}  VT_Int    , VT_Path   , VT_Links  , VT_Table  , VT_VPoint , VT_Links  , VT_Links  , VT_Table  , VT_Link   , VT_Bool   ,
    {680}  VT_Link   , VT_Links  , VT_Int    , VT_Path   , VT_Link   , VT_Link   , VT_Link   , VT_Link   , VT_Point  , VT_Int    ,
    {690}  VT_Int    , VT_Bool   , VT_Links  , VT_Table  , VT_Int    , VT_Int    , VT_String , VT_Bool   , VT_Links  , VT_Bool   ,
           {0}         {1}         {2}         {3}         {4}         {5}         {6}         {7}         {8}         {9}
    {700}  VT_String , VT_String , VT_Int    , VT_String , VT_Links  , VT_Table  , VT_Path   , VT_VPath  , VT_Path   , VT_Float  ,
    {710}  VT_Int    , VT_Int    , VT_Bool   , VT_Float  , VT_Float  , VT_Float  , VT_Int    , VT_Links  , VT_Int    , VT_Bool   ,
    {720}  VT_Int    , VT_Bool   , VT_Int    , VT_Bool   , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_VPath  , VT_Int    ,
    {730}  VT_Bool   , VT_Int    , VT_Int    , VT_Int    , VT_Point  , VT_Link   , VT_Point  , VT_String , VT_String , VT_Int    ,
    {740}  VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Bool   , VT_Int    , VT_Int    , VT_Int    , VT_Float  ,
    {750}  VT_Int    , VT_Int    , VT_Int    , VT_VFloat , VT_VInt   , VT_Link   , VT_Int    , VT_Int    , VT_Int    , VT_String ,
    {760}  VT_VFloat , VT_VText  , VT_Bool   , VT_Bool   , VT_Path   , VT_Path   , VT_Link   , VT_Link   , VT_Link   , VT_Bool   ,
    {770}  VT_Link   , VT_Path   , VT_Float  , VT_Int    , VT_Bool   , VT_Int    , VT_Float  , VT_Bool   , VT_Point  , VT_Point  ,
    {780}  VT_Int    , VT_Int    , VT_Int    , VT_Float  , VT_Point  , VT_Int    , VT_Float  , VT_Int    , VT_Path   , VT_Bool   ,
    {790}  VT_Bool   , VT_Path   , VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Float  , VT_Point  , VT_Int    , VT_Float  ,
           {0}         {1}         {2}         {3}         {4}         {5}         {6}         {7}         {8}         {9}
    {800}  VT_Int    , VT_Bool   , VT_Int    , VT_VString, VT_VString, VT_Float  , VT_String , VT_VPath  , VT_Path   , VT_String ,
    {810}  VT_Links  , VT_Int    , VT_Float  , VT_Float  , VT_Float  , VT_Float  , VT_Links  , VT_Table  , VT_Path   , VT_String ,
    {820}  VT_Links  , VT_String , VT_String , VT_String , VT_Link   , VT_Link   , VT_Bool   , VT_Table  , VT_Links  , VT_Int    ,
    {830}  VT_Links  , VT_String , VT_Table  , VT_Links  , VT_Links  , VT_Links  , VT_Links  , VT_Links  , VT_Links  , VT_Bool   ,
    {840}  VT_Int    , VT_Int    , VT_Int    , VT_Int    , VT_Links  , VT_VBool  , VT_Link   , VT_Int    , VT_Int    , VT_VInt   ,
    {850}  VT_Link   , VT_Link   , VT_Link   , VT_Link   , VT_Link   , VT_Link   , VT_Link   , VT_VString, VT_Links  , VT_Table  ,
    {860}  VT_Bool   , VT_String , VT_String , VT_Links  , VT_Link   , VT_Link   , VT_Link   , VT_Int    , VT_Links  , VT_Table  ,
    {870}  VT_Links  , VT_Links  , VT_Table  , VT_Links  , VT_String , VT_String , VT_Point  , VT_Links  , VT_Bool   , VT_Link   ,
    {880}  VT_Link   , VT_Links  , VT_Link   , VT_Int    , VT_Int    , VT_Link   , VT_Int    , VT_Int    , VT_Int    , VT_Int    ,
    {890}  VT_Links  , VT_Int    , VT_Links  , VT_Links  , VT_Table  , VT_VPoint , VT_Int    , VT_Links  , VT_Table  , VT_Int    ,
           {0}         {1}         {2}         {3}         {4}         {5}         {6}         {7}         {8}         {9}
    {900}  VT_String , VT_Links  , VT_Links  , VT_String , VT_String , VT_Links  , VT_Links  , VT_Links  , VT_Links  , VT_Bool   ,
    {910}  VT_Bool   , VT_Point  , VT_Point  , VT_Int    , VT_Int    , VT_Int    , VT_Point);

  TableIdMapping: array[1..MaxVisIdentifierID] of Longint =
    {001} (    -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {010}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {020}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {030}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {040}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {050}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {060}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {070}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {080}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {090}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {100}  -1,  4,  1,  3,  5,  0,  2,  6,  7,  8,
    {110}   9, 10, 11, 12, 13, 14, -1, -1, -1, -1,
    {120}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {130}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {140}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {150}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {160}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {170}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {180}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {190}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {200}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {210}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {220}  -1, -1, -1, -1, -1, 15, -1, -1, -1, -1,
    {230}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {240}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {250}  -1, -1, -1, -1, 19, -1, -1, -1, -1, -1,
    {260}  18, -1, 16, -1, -1, 17, -1, -1, -1, -1,
    {270}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {280}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {290}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {300}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {310}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {320}  -1, -1, -1, -1, -1, -1, 20, -1, -1, -1,
    {330}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {340}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {350}  -1, 21, -1, -1, -1, -1, -1, -1, -1, -1,
    {360}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {370}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {380}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {390}  22, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {400}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {410}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {420}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {430}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {440}  -1, -1, -1, -1, -1, -1, -1, -1, -1, 23,
    {450}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {460}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {470}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {480}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {490}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {500}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {510}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {520}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {530}  -1, -1, 24, -1, 25, -1, 26, -1, -1, -1,
    {540}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {550}  -1, -1, -1, -1, -1, -1, -1, 27, -1, -1,
    {560}  -1, -1, -1, -1, -1, -1, -1, -1, -1, 28,
    {570}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {580}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {590}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {600}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {610}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {620}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {630}  -1, -1, -1, -1, -1, -1, 29, -1, -1, -1,
    {640}  -1, -1, -1, -1, -1, -1, -1, -1, -1, 30,
    {650}  -1, -1, -1, -1, -1, -1, -1, 31, -1, -1,
    {660}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {670}  -1, -1, 32, -1, -1, -1, 33, -1, -1, -1,
    {680}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {690}  -1, -1, 34, -1, -1, -1, -1, -1, -1, -1,
    {700}  -1, -1, -1, -1, 35, -1, -1, -1, -1, -1,
    {710}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {720}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {730}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {740}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {750}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {760}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {770}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {780}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {790}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {800}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {810}  -1, -1, -1, -1, -1, -1, 36, -1, -1, -1,
    {820}  -1, -1, -1, -1, -1, -1, -1, -1, 37, -1,
    {830}  -1, -1, -1, 38, -1, -1, -1, -1, -1, -1,
    {840}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {850}  -1, -1, -1, -1, -1, -1, -1, -1, 39, -1,
    {860}  -1, -1, -1, -1, -1, -1, -1, -1, 40, -1,
    {870}  -1, 41, -1, -1, -1, -1, -1, -1, -1, -1,
    {880}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {890}  -1, -1, -1, 42, -1, -1, -1, 43, -1, -1,
    {900}  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    {910}  -1, -1, -1, -1, -1, -1, -1);

function MapVisType(const NameID: Word): TVisType;
begin
  Result := VT_Unknown;

  if (NameID >= Low(VisTypeMapping)) and (NameID <= High(VisTypeMapping)) then
    Result := VisTypeMapping[NameID];

  if Result = VT_Unknown then
    WriteLn(Format('    warning: no known type mapping for %d', [NameID]))
end;

function MapTableId(const NameID: Word): Longint;
begin
  Result := -1;

  if (NameID >= Low(TableIdMapping)) and (NameID <= High(TableIdMapping)) then
    Result := TableIdMapping[NameID];

  if Result = -1 then
    WriteLn(Format('    warning: no known table id mapping for %d', [NameID]))
end;

end.
