{ File    : $URL: file:///D:/SVN/svnDelphi/branches/A%20New%20Beginning/VISExt/servicing/src/convert/VEDMapEx.pas $
  Author  : $Author: Deniz Oezmen $
  Changed : $Date: 2021-04-03 22:48:36 +0200 (Sa, 03 Apr 2021) $
  Revision: $Rev: 588 $

  Visionaire Engine types and mappings
}
unit VEDMapEx;

interface

function MapIdentifier(const Identifier: WideString;
  IsDataField: Boolean = False): WideString;
function MapIdentifierInverse(const Identifier: WideString;
  IsDataField: Boolean = False): WideString;
function MapSaveFix(const Identifier: WideString): WideString;
function MapSaveFixInverse(const Identifier: WideString): WideString;

implementation

uses
  VEDMap,
  SysUtils;

const
  IdentifierMapping: array[1..MaxVisIdentifierID] of WideString =
    {001} ({,} 'x', 'y', 'top', 'left', 'bottom', 'right', 'path', 'position', 'cutting',
    {010}  'transparent', 'areaInFront', 'name', 'id', 'order', 'Link', 'Links', 'version', 'newId', 'tableId',
    {020}  'field', 'parentLink', 'rect', 'motiv', 'point', 'string', 'text', 'int', 'standing', 'sprite',
    {030}  'spritepart', 'spriteparts', 'pause', 'SaveGame', 'float', 'SavedObject', 'LinkAny', 'Clipboard', 'ClipboardObjects', 'type',
    {040}  'Structures', 'Structure', 'Attribute', 'Field', 'value', 'ValidLinks', 'tablecount', 'ObjFilter', 'ObjFilterPair', 'ObjFilterArray',
    {050}  'Transparency', 'TranspColor', 'versionedId', 'projectType', 'revision', 'lastModified', 'ClipboardParentTable', 'ClipboardParentField', 'DSunused', 'DSunused',
    {060}  'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused',
    {070}  'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused',
    {080}  'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused',
    {090}  'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused', 'DSunused',
    {100}  'VisionaireAdventure', 'Scenes', 'Interfaces', 'Fonts', 'Points', 'Characters', 'Buttons', 'Objects', 'Actions', 'ActionParts',
    {110}  'Animations', 'Conditions', 'Dialogs', 'DialogParts', 'Sprites', 'Texts', 'Game', 'GameSceneLinks', 'GameCharacterLinks', 'GameBagLinks',
    {120}  'GameFontLinks', 'GameFirstScene', 'FixtureScreen', 'CurrentBag', 'GameDescription', 'GameAbout', 'GameWindowResolution', 'CurrentFont', 'Comments', 'Scene',
    {130}  'BackgroundImage', 'SceneAction', 'SceneBackgroundMusic', 'CDTrack', 'SceneCharacter', 'ScenePoints', 'SceneObjects', 'Interface', 'InterfaceScrollStepSize', 'InterfaceBackground',
    {140}  'InterfaceButtons', 'Font', 'FontMotiv', 'FontLetters', 'Point', 'PointSize', 'PointPosition', 'PointRelations', 'Character', 'CharacterMirror',
    {150}  'CharacterMirrored', 'CharacterAnimations', 'Button', 'ButtonAction', 'ButtonArea', 'ButtonImages', 'ButtonImageActive', 'ButtonImageInActive', 'Action', 'ActionExecutionType',
    {160}  'ActionFixture', 'ActionCommand', 'ActionActionParts', 'Object', 'ObjectNameLang1', 'ObjectNameLang2', 'ObjectGender', 'ObjectPoint', 'ObjectArea', 'ObjectCondition',
    {170}  'ObjectSprite', 'ObjectAnimation', 'ObjectActions', 'ObjectTexts', 'ObjectSprites', 'ObjectConditions', 'ObjectAnimations', 'ObjectDialogs', 'ActionPart', 'ActionPartCommand',
    {180}  'ActionPartLink', 'ActionPartPath', 'Animation', 'AnimationLoop', 'AnimationLoopRandom', 'AnimationOppositeDirection', 'AnimationRandomOrder', 'AnimationNumberOfLoops', 'AnimationPause', 'AnimationPosition',
    {190}  'AnimationAction', 'AnimationParts', 'Condition', 'ConditionIsVariable', 'ConditionValue', 'ConditionReturnNegate', 'ConditionCondition1Negate', 'ConditionCondition2Negate', 'ConditionOperator', 'ConditionCondition1',
    {200}  'ConditionCondition2', 'Dialog', 'DialogDialogParts', 'DialogPart', 'DialogPartCondition', 'DialogPartText', 'DialogPartAction', 'Sprite', 'SpriteMotiv', 'Text',
    {210}  'TextLang1', 'TextLang2', 'TextSound1', 'TextSound2', 'TextLangAll', 'GameCursors', 'TextSoundAll', 'ObjectNameLangAll', 'SceneBorders', 'DialogPartConditionValue',
    {220}  'ObjectAreaPolygon', 'ObjectAreaCenter', 'ObjectDirection', 'AnimationFile', 'GameIntro', 'Cursors', 'Cursor', 'CursorImagesActive', 'CursorImagesInActive', 'ButtonCursor',
    {230}  'StandardCursor', 'LoadingScreen', 'SceneScrollOnEdges', 'SceneBagVisible', 'GameFadeDelay', 'AnimationSprites', 'SceneSprite', 'SpriteSprite', 'InterfaceSprite', 'CursorHotspot',
    {240}  'CursorSpritesActive', 'CursorSpritesInActive', 'ActionPartInt', 'StandardCommand', 'GameCommandBehaviour', 'CharacterSpeed', 'GameScrollSpeed', 'GameFullScreenIntro', 'FontSprite', 'FontAlphabet',
    {250}  'FontLetterSpacing', 'ObjectName', 'ObjectAlwaysInFront', 'TextAll', 'TextLanguages', 'TextLanguage', 'TextLanguageText', 'TextLanguageSound', 'TextLanguageLanguage', 'GameLanguages',
    {260}  'Languages', 'Language', 'CommentSets', 'CommentSet', 'CommentSetElements', 'Outfits', 'Outfit', 'OutfitWalkAnimations', 'OutfitTalkAnimations', 'OutfitCharacterAnimations',
    {270}  'OutfitCharacterSpeed', 'CharacterName', 'CharacterWalkingSound', 'CharacterCurrentInterface', 'CharacterCurrentInventory', 'CharacterFont', 'CharacterCurrentOutfit', 'CharacterCurrentCommentSet', 'CharacterDialogs', 'CharacterTexts',
    {280}  'CharacterActions', 'CharacterOutfits', 'CharacterCommentSets', 'CharacterDialogCursor', 'AnimationMirror', 'AnimationDirection', 'DialogPartAnswerText', 'DialogPartReturn', 'DialogPartRemove', 'DialogPartNextDialog',
    {290}  'ActionPartAltLink', 'ActionPartAltInt', 'SceneIsMenu', 'SceneCursor', 'SceneKey', 'ButtonName', 'ButtonConjunction', 'ButtonType', 'InterfaceStandardCommand', 'BagVisibility',
    {300}  'BagKey', 'BagInventory', 'InterfaceOffset', 'GameFirstCharacter', 'GameRightMouseClick', 'GameDraggableItems', 'GameStandardLanguage', 'GameSaveKey', 'GameLoadKey', 'ActionTextFont',
    {310}  'ActionTextRect', 'CharacterStartObject', 'ButtonSpriteActive', 'ButtonSpriteInActive', 'InterfaceDisplacement', 'SceneMusicVolume', 'SceneMusicBalance', 'DialogPartAvailable', 'GameActions', 'InterfaceActionTextRect',
    {320}  'InterfaceActionTextFont', 'OutfitRandomAnimations', 'SceneSavegameAreas', 'SceneSavegameScrollStep', 'InterfaceSize', 'InterfaceBorder', 'Values', 'Value', 'ValueInt', 'ObjectCenter',
    {330}  'SceneConditions', 'CharacterConditions', 'SceneValues', 'ObjectValues', 'CharacterValues', 'SceneActions', 'ButtonUse', 'GameRightClickAction', 'AnimationMove', 'ObjectPosition',
    {340}  'SceneBorderPoints', 'ObjectPolygon', 'ButtonActiveSprite', 'ButtonInactiveSprite', 'AnimationUseIndividualPause', 'ValueRandom', 'ValueRandomMin', 'ValueRandomMax', 'SceneSavegameFont', 'GameItems',
    {350}  'ObjectIsItem', 'Loadings', 'Loading', 'LoadingSprite', 'LoadingStatusBar', 'LoadingStatusSprite', 'LoadingStatusCover', 'LoadingMusic', 'GameLoading', 'ObjectConditionNegate',
    {360}  'AnimationStandingSprite', 'SObjectArea', 'GameTexts', 'SceneTexts', 'SceneName', 'SceneContinueMusic', 'AnimationResetPosition', 'AnimationCenter', 'GameStartAction', 'GameReserved',
    {370}  'GameId', 'LoadingStatusSpriteLink', 'GameDialogScrollUp', 'GameDialogScrollDown', 'GameDialogScrollMax', 'GameDialogShowMax', 'ValueCurrent', 'GameHoldTime', 'GameLeftMouseDblClick', 'GameLeftDblClickAction',
    {380}  'GameLeftMouseHold', 'GameLeftHoldAction', 'ButtonAreaAction', 'OutfitStandingAnimations', 'ObjectIsWalkable', 'GameLeftMouseHolding', 'GameLeftHoldingAction', 'ButtonUseOnOwnCharacter', 'InterfaceLeaveAction', 'InterfaceTextOnScreen',
    {390}  'Particles', 'Particle', 'ParticleTexture', 'ParticleMaterialMode', 'ParticleTilesX', 'ParticleTilesY', 'ParticleType', 'ParticleXPos', 'ParticleYPos', 'ParticleEmitterType',
    {400}  'ParticleEmitterWidth', 'ParticleEmitterHeight', 'ParticleEmitterDepth', 'ParticleMaxParticles', 'ParticlePerTime', 'ParticlePhiX', 'ParticlePhiY', 'ParticleMinSize', 'ParticleMaxSize', 'ParticleMinVelocity',
    {410}  'ParticleMaxVelocity', 'ParticleMinLife', 'ParticleMaxLife', 'ParticleMinColor', 'ParticleMaxColor', 'ParticleRotationX', 'ParticleRotationZ', 'ParticleActiveStages', 'ParticleBlendColor0', 'ParticleBlendColor1',
    {420}  'ParticleBlendColor2', 'ParticleBlendColor3', 'ParticleBlendColorCurve0', 'ParticleBlendColorCurve1', 'ParticleBlendColorCurve2', 'ParticleBlendColorCurve3', 'ParticleColorControlPoints0', 'ParticleColorControlPoints1', 'ParticleColorControlPoints2', 'ParticleColorControlPoints3',
    {430}  'ParticleForceType', 'ParticleForceStrength', 'ParticleForceRotationX', 'ParticleForceRotationZ', 'ParticleForceXPos', 'ParticleForceYPos', 'ParticleForceZPos', 'ParticleForceBlend', 'ParticleBlendSizeCurve', 'ParticleSizeControlPoints',
    {440}  'GameParticleLinks', 'SceneParticleSystem', 'ParticleContainerLeadTime', 'ParticleBlendMaxTile', 'ParticleBlendTilesCurve', 'ParticleBlendTilesControlPoints', 'ParticleContainerCameraZPosition', 'ParticleContainerCameraZoom', 'GameParticleContainerLinks', 'ParticleContainers',
    {450}  'ParticleContainer', 'ParticleContainerParticles', 'InterfaceConditions', 'InterfaceValues', 'ButtonPolygon', 'ButtonActions', 'CharacterScale', 'CharacterActiveDialogFont', 'CharacterDialogArea', 'CharacterDialogActiveScrollUp',
    {460}  'CharacterDialogInactiveScrollUp', 'CharacterDialogActiveScrollDown', 'CharacterDialogInactiveScrollDown', 'CharacterDialogSprite', 'CharacterDialogVerticalSpace', 'DialogPartAltText', 'DialogPartUseAltText', 'ObjectParticleSystem', 'GameCurrentCharacter', 'GameCurrentScene',
    {470}  'GameScrollPosition', 'GameScrollToPoint', 'GameScrollTo', 'GameScrollDirectionHorizontal', 'GameScrollDirectionVertical', 'GameWaitForDialogSelection', 'GameDialog', 'GameCurrentText', 'GameBackgroundTexts', 'GameHideInterfaces',
    {480}  'GameHideCursor', 'GameDialogAction', 'GameCurrentDialogAction', 'GameDestinationCommand', 'GameDestinationItem', 'GameDestinationItemPicked', 'GameSavedObject', 'GameObjectSaved', 'ActionActionPartStarted', 'ActionActionPartIndex',
    {490}  'ActionContinueWaitForEndIfElse', 'ActionTimerStarted', 'ActionPauseTime', 'AnimationLoops', 'AnimationCurrentSpriteIndex', 'AnimationCurrentSpritePos', 'AnimationCurrentPosition', 'AnimationCalledTime', 'AnimationOwner', 'AnimationSize',
    {500}  'AnimationWaiting', 'AnimationWaitingTime', 'CharacterActive', 'CharacterScene', 'CharacterFollowCharacter', 'CharacterActionCharacter', 'CharacterFollowAction', 'CharacterFollowReachDistance', 'CharacterAnimState', 'CharacterCurrentSprite',
    {510}  'CharacterDirectionIndex', 'CharacterState', 'CharacterPosition', 'CharacterDestination', 'CharacterItemsDeprecated', 'CharacterDestinationObject', 'CharacterExecuteDestObject', 'CharacterActiveCommand', 'CharacterItemsScrollPosition', 'CharacterInterfaceActive',
    {520}  'CharacterInventoryActive', 'TextRemainingText', 'TextCurrentText', 'TextPosition', 'TextTimeToWait', 'TextTimeElapsed', 'TextFont', 'TextBackground', 'TextSpeaker', 'TextActive',
    {530}  'TextWaitForAudio', 'ActiveText', 'ActiveTexts', 'ActiveAction', 'ActiveActions', 'ActiveAnimation', 'ActiveAnimations', 'GameSaveGameName', 'ObjectScrollFactorX', 'ObjectScrollFactorY',
    {540}  'VerticalLetterSpacing', 'PlayOppositeDirection', 'FrameCount', 'ButtonCondition', 'ButtonConditionNegate', 'ButtonAnimation', 'ButtonAnimations', 'GameFadeEffect', 'GameMinificationFilter', 'GameMagnificationFilter',
    {550}  'SceneLightMap', 'CharacterInterfaceAlpha', 'CharacterInventoryAlpha', 'CharacterAlpha', 'CharacterDestAlpha', 'CharacterTimeToDestAlpha', 'SceneBrightness', 'CommentSetEntries', 'CommentSetEntry', 'CommentSetEntryText',
    {560}  'CommentSetEntryCommand', 'GameScrollCenterCharacter', 'GameLeftMouseClick', 'GameLeftClickAction', 'CharacterAnimIndex', 'GameAlwaysAllowSkipText', 'CharacterScaleFactor', 'ButtonDraggable', 'SceneScrollableArea', 'AnimationFrames',
    {570}  'AnimationFrame', 'AnimationFrameIndex', 'AnimationFrameSound', 'AnimationFrameSoundVolume', 'AnimationFrameSoundBalance', 'AnimationFrameAction', 'AnimationPropertyFrames', 'AnimationPreloaded', 'GameExecuteActionsDuringDialog', 'GameHiddenDialog',
    {580}  'AnimationActive', 'CharacterInactiveDialogFont', 'GameAlignCharacterOnImExecution', 'GameTextOutput', 'ButtonGroup', 'CharacterInterfaces', 'InterfaceActive', 'InterfaceDrawActionText', 'GameDrawActionText', 'GameActionTextFont',
    {590}  'GameActionTextRect', 'ActionPartAltInt2', 'GameSpeakerTextAlignment', 'GameTextAlignment', 'SceneBrightness', 'CharacterVisibility', 'CharacterDestVisibility', 'CharacterTimeToDestVisibility', 'CharacterInterfaceWithItems', 'CharacterDirection',
    {600}  'ObjectVisibility', 'ObjectDestVisibility', 'ObjectTimeToDestVisibility', 'InterfaceVisibility', 'InterfaceDestVisibility', 'InterfaceTimeToDestVisibility', 'InterfaceVisible', 'InterfaceActiveCommand', 'InterfaceItems', 'InterfaceItemsScrollPosition',
    {610}  'GameActiveCommand', 'GameScrollCharacter', 'ButtonCommandType', 'ButtonUseOnCurrentCharacter', 'DialogPartConditionNegate', 'GameDestinationEvent', 'GameComposedFile', 'GameSceneComposedFiles', 'GameSceneComposedFile', 'GameCharacterComposedFiles',
    {620}  'GameCharacterComposedFile', 'GameMovieComposedFiles', 'GameMovieComposedFile', 'FontSpaceWidth', 'TextSavedObject', 'ActionSavedObject', 'AnimationSavedObject', 'GameVersion', 'GameAutoHideInterfacesInMenu', 'GameQuake',
    {630}  'GameQuakeForce', 'GameQuakeSpeed', 'ValueString', 'GameCutsceneAction', 'FontAutoLineBreak', 'FontLineWidth', 'WaySystems', 'WaySystem', 'WaySystemBorder', 'WaySystemPoints',
    {640}  'SceneWaySystems', 'SceneCurrentWaySystem', 'GameKeepCharacterSpritesDuringMenus', 'GameDisableInteractionDuringAnim', 'AnimationFirstFrame', 'AnimationLastFrame', 'GameTextSpeed', 'CursorActiveAnimation', 'CursorInactiveAnimation', 'Scripts',
    {650}  'Script', 'GameScriptLinks', 'ScriptScript', 'ScriptType', 'ActionPartString', 'DialogPartLinkedAction', 'AnimationReplay', 'InterfaceClasses', 'InterfaceClass', 'InterfaceInterfaceClass',
    {660}  'InterfaceClassName', 'GameInterfaceClasses', 'GameInterfaces', 'CharacterItems', 'CharacterTint', 'ObjectSnoopAnimation', 'ObjectSnoopAnimationPos', 'GameHorizontalScrollDistance', 'GameVerticalScrollDistance', 'GamePictureCacheSize',
    {670}  'GameInterfaceComposedFiles', 'GameInterfaceComposedFile', 'ActionAreas', 'ActionArea', 'ActionAreaPolygon', 'ActionAreaActions', 'AreaActions', 'AreaAction', 'AreaActionCharacter', 'AreaActionExecuteAlways',
    {680}  'AreaActionAction', 'SceneActionAreas', 'GameGameComposedFiles', 'GameGameComposedFile', 'TextOwner', 'GameObjectFont', 'GameUsedItem', 'GameCurrentObject', 'InterfacePosition', 'GameCursorHorizontalScrollDistance',
    {690}  'GameCursorVerticalScrollDistance', 'AnimationStartedByUser', 'ScriptVariables', 'ScriptVariable', 'ScriptVariableKeyType', 'ScriptVariableValueType', 'ScriptVariableValue', 'ScriptVariableIsGlobalVar', 'ScriptVariableItems', 'GameVideosEncrypted',
    {700}  'GameCompanyName', 'GameGameName', 'GameObjectTextOutput', 'FontKerning', 'Models', 'Model', 'ModelModel', 'ModelTextures', 'OutfitModel', 'OutfitCameraDistance',
    {710}  'OutfitCameraHeight', 'OutfitCameraAngle', 'OutfitUseLight', 'OutfitLightPosX', 'OutfitLightPosY', 'OutfitLightPosZ', 'OutfitLightColor', 'GameModelLinks', 'OutfitModelScaleFactor', 'OutfitModelShowShadow',
    {720}  'OutfitModelShadowTranslucency', 'OutfitModelUseToonShading', 'OutfitModelToonNuances', 'OutfitModelShowOutline', 'OutfitModelOutlineColor', 'OutfitModelOutlineWidth', 'AnimationModelAnimIndex', 'AnimationModelAnimSpeed', 'OutfitModelTextures', 'OutfitAmbientLightColor',
    {730}  'GameUsedItemPicked', 'GamePreloadPicThreads', 'GamePreloadedPicBufferSize', 'GamePicBufferSize', 'CharacterActionDestPosition', 'GameVideoSubtitleFont', 'GameVideoSubtitlePosition', 'GameVideoSubtitleLanguage', 'GameVideoAudioLanguage', 'GamePreallocatedTextures3Bpt',
    {740}  'GamePreallocatedTextures4Bpt', 'ParticlePosX', 'ParticlePosY', 'GamePreallocatedTextures', 'TextAlignment', 'GameNearestNeighborInterpolation', 'ParticleEmitterSizeX', 'ParticleEmitterSizeY', 'ParticleEmitterSizeZ', 'CharacterSize',
    {750}  'OutfitModelShadowVisibility', 'OutfitModelShadow', 'OutfitModelAmbientOcclusion', 'OutfitWalkCycleCurve', 'OutfitWalkCyclePoints', 'GameSpeechLanguage', 'OutfitRandomMinTime', 'OutfitRandomMaxTime', 'SpeakerSoundPanFactor', 'GameRegisteredEventHandlers',
    {760}  'AnimationWalkSteps', 'TextTextLanguages', 'OutfitSlideWalkAnimation', 'GameShowBlackScreenAfterVideo', 'GameSavegameScreenshot', 'SceneSavegameScreenshot', 'GameMiddleClickAction', 'GameMouseWheelUpAction', 'GameMouseWheelDownAction', 'FontTrueTypeFont',
    {770}  'FontFont', 'FontTrueTypeFontPath', 'FontSize', 'FontColor', 'FontBorder', 'FontBorderColor', 'FontBorderSize', 'FontShadow', 'FontShadowOffset', 'ObjectOffset',
    {780}  'GameLeftHoldBehaviour', 'GameMiddleClickBehaviour', 'GameRightClickBehaviour', 'ObjectRotation', 'ObjectRotationCenter', 'ObjectShaderSet', 'ObjectScale', 'GameShaderExclude', 'GameVideoPauseScreen', 'InterfaceShowAlways',
    {790}  'GameExecuteCalledActionImmediately', 'ObjectModel', 'ObjectMatrixId', 'CharacterMatrixId', 'SceneShaderSet', 'CharacterShaderSet', 'ButtonRotation', 'ButtonRotationCenter', 'ButtonShaderSet', 'ButtonScale',
    {800}  'ButtonMatrixId', 'CharacterLightmapActive', 'InterfaceMatrixId', 'GameContainers', 'GameBuildRules', 'ValueFloat', 'ParticleContainerSettings', 'OutfitModelFiles', 'AnimationModelFile', 'AnimationModelName',
    {810}  'OutfitTurnAnimations', 'AnimationEndDirection', 'ObjectScaleX', 'ObjectScaleY', 'ButtonScaleX', 'ButtonScaleY', 'Shaders', 'Shader', 'GameIconFile', 'GameBuildOptions',
    {820}  'GameShaderLinks', 'ShaderFS', 'ShaderVS', 'ShaderCompiled', 'ParticleContainerPreviewScene', 'DialogCharacter', 'GameSmoothScrolling', 'AudioBus', 'AudioBusses', 'AudioBusType',
    {830}  'AudioBusLinks', 'AudioBusSettings', 'Event', 'Events', 'GameAudioMixLinks', 'GameAudioContainerLinks', 'AudioBusValues', 'AudioBusEvents', 'SceneAudioBusses', 'CharacterHarmonizeWalkAnimations',
    {840}  'GameOverlayVisibility', 'GameOverlayColor', 'ActionSavedValue', 'GameSaveNameOffsetY', 'ConditionConditions', 'ConditionConditionsNegate', 'ObjectValue', 'ObjectValueOperator', 'ObjectValueInt', 'AnimationPauses',
    {850}  'AudioBusOutputBus', 'GameDefaultSpeechBus', 'GameDefaultSoundBus', 'GameWalksoundBus', 'GameDefaultMusicBus', 'CharacterAudioBus', 'GameCursor', 'GameCustomActionParts', 'Plugins', 'Plugin',
    {860}  'PluginActive', 'PluginDirectory', 'PluginData', 'GamePlugins', 'EventAction', 'EventStartBus', 'EventStopBus', 'OutfitModelTurnSpeed', 'BlockContainers', 'BlockContainer',
    {870}  'BlockContainerBlocks', 'Blocks', 'Block', 'BlockLinks', 'BlockConfig', 'BlockTypeName', 'BlockPosition', 'GameBlockContainers', 'BlockActive', 'SceneTestCharacter',
    {880}  'GameWaitCursor', 'AudioBusLinkedObjects', 'ButtonValue', 'ButtonValueOperator', 'ButtonValueInt', 'DialogPartValue', 'DialogPartValueOperator', 'DialogPartValueInt', 'ButtonVisibility', 'BlockType',
    {890}  'GameBehaviours', 'GameLeftClickBehaviour', 'SceneCurves', 'Curves', 'Curve', 'CurvePoints', 'CurveType', 'Components', 'Component', 'ComponentType',
    {900}  'ComponentData', 'ComponentLinks', 'ObjectComponents', 'BlockContainerCode', 'BlockContainerSource', 'SceneComponents', 'ButtonComponents', 'CharacterComponents', 'InterfaceComponents', 'ActionPartDisabled',
    {910}  'ObjectLightmapAffected', 'GameFadeCenter', 'GameFadeInCenter', 'GameFadeRadius', 'GameQuakeForceX', 'GameQuakeForceY', 'ButtonOffset');

function MapSaveFix(const Identifier: WideString): WideString;
begin
  if WideLowerCase(Identifier) = WideLowerCase('ActiveAnimation') then
    Result := 'AnimationSave'
  else if WideLowerCase(Identifier) = WideLowerCase('ActiveAnimations') then
    Result := 'AnimationsSave'
  else if WideLowerCase(Identifier) = WideLowerCase('ActiveAction') then
    Result := 'ActionSave'
  else if WideLowerCase(Identifier) = WideLowerCase('ActiveActions') then
    Result := 'ActionsSave'
  else if WideLowerCase(Identifier) = WideLowerCase('ActiveText') then
    Result := 'TextSave'
  else if WideLowerCase(Identifier) = WideLowerCase('ActiveTexts') then
    Result := 'TextsSave'
  else
    Result := Identifier
end;

function MapSaveFixInverse(const Identifier: WideString): WideString;
begin
  if WideLowerCase(Identifier) = WideLowerCase('AnimationSave') then
    Result := 'ActiveAnimation'
  else if WideLowerCase(Identifier) = WideLowerCase('AnimationsSave') then
    Result := 'ActiveAnimations'
  else if WideLowerCase(Identifier) = WideLowerCase('ActionSave') then
    Result := 'ActiveAction'
  else if WideLowerCase(Identifier) = WideLowerCase('ActionsSave') then
    Result := 'ActiveActions'
  else if WideLowerCase(Identifier) = WideLowerCase('TextSave') then
    Result := 'ActiveText'
  else if WideLowerCase(Identifier) = WideLowerCase('TextsSave') then
    Result := 'ActiveTexts'
  else
    Result := Identifier
end;

function MapIdentifier(const Identifier: WideString;
  IsDataField: Boolean = False): WideString;
var
  Id: Longint;
begin
  if (Identifier <> '') and (Identifier[1] = 'T') then
    if TryStrToInt(Copy(Identifier, 2, Length(Identifier) - 1), Id) then
    begin
      if (Id < Low(IdentifierMapping)) or (Id > High(IdentifierMapping)) or
        (IdentifierMapping[Id] = '') then
        WriteLn('    warning: no known mapping for "', Identifier, '"')
      else if IdentifierMapping[Id] = 'DSunused' then
        WriteLn('    warning: "', Identifier, '" marked as unused')
      else
      begin
        Result := IdentifierMapping[Id];
        if IsDataField then
          Result := 'V' + Result;

        Exit
      end;
    end;

  Result := Identifier
end;

function MapIdentifierInverse(const Identifier: WideString;
  IsDataField: Boolean = False): WideString;
var
  i      : Longint;
  Pattern: WideString;
begin
  if (Identifier <> '') then
  begin
    if (Identifier[1] = 'V') and (Length(Identifier) > 1) and IsDataField then
      Pattern := WideLowerCase(Copy(Identifier, 2, Length(Identifier) - 1))
    else
      Pattern := WideLowerCase(Identifier);

    if Pattern <> 'DSunused' then
      for i := Low(IdentifierMapping) to High(IdentifierMapping) do
        if WideLowerCase(IdentifierMapping[i]) = Pattern then
        begin
          Result := 'T' + IntToStr(i);
          Exit
        end;

    WriteLn('    warning: no known mapping for "', Identifier, '"')
  end;

  Result := Identifier
end;

end.
